Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/include/Parameters.h	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/include/Parameters.h	(revision 78)
@@ -55,5 +55,5 @@
   public : ~Parameters () ;
 
-  public :        std::string   msg_error  (void);
+  public :        Parameters_test msg_error  (void);
 
   public :        std::string   print      (uint32_t depth);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/src/Execute_queue_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/src/Execute_queue_allocation.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/src/Execute_queue_allocation.cpp	(revision 78)
@@ -54,6 +54,6 @@
        ALLOC_INTERFACE ("execute_queue_in", IN, WEST, "Input of execute_queue");
        
-       ALLOC_VAL_IN    ( in_EXECUTE_QUEUE_IN_VAL);
-       ALLOC_ACK_OUT   (out_EXECUTE_QUEUE_IN_ACK);
+       ALLOC_VALACK_IN ( in_EXECUTE_QUEUE_IN_VAL,VAL);
+       ALLOC_VALACK_OUT(out_EXECUTE_QUEUE_IN_ACK,ACK);
        if(_param->_have_port_context_id)
        ALLOC_SIGNAL_IN ( in_EXECUTE_QUEUE_IN_CONTEXT_ID   ,"context_id"   ,Tcontext_t        ,_param->_size_context_id       );
@@ -76,6 +76,6 @@
        ALLOC_INTERFACE ("execute_queue_out", OUT, EAST, "Output of execute_queue");
        
-       ALLOC_VAL_OUT   (out_EXECUTE_QUEUE_OUT_VAL);
-       ALLOC_ACK_IN    ( in_EXECUTE_QUEUE_OUT_ACK);
+       ALLOC_VALACK_OUT(out_EXECUTE_QUEUE_OUT_VAL,VAL);
+       ALLOC_VALACK_IN ( in_EXECUTE_QUEUE_OUT_ACK,ACK);
        if(_param->_have_port_context_id)
        ALLOC_SIGNAL_OUT(out_EXECUTE_QUEUE_OUT_CONTEXT_ID   ,"context_id"   ,Tcontext_t     ,_param->_size_context_id   );
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/src/Parameters_msg_error.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Execute_queue/src/Parameters_msg_error.cpp	(revision 78)
@@ -22,13 +22,13 @@
 #undef  FUNCTION
 #define FUNCTION "Execute_queue::msg_error"
-  std::string Parameters::msg_error(void)
+  Parameters_test Parameters::msg_error(void)
   {
     log_printf(FUNC,Execute_queue,FUNCTION,"Begin");
 
-    std::string msg = "";
-
-    return msg;
+    Parameters_test test ("Execute_queue");
 
     log_printf(FUNC,Execute_queue,FUNCTION,"End");
+
+    return test;
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Write_queue/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Write_queue/include/Parameters.h	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Write_queue/include/Parameters.h	(revision 78)
@@ -66,5 +66,5 @@
   public : ~Parameters () ;
 
-  public :        std::string   msg_error  (void);
+  public :        Parameters_test msg_error  (void);
 
   public :        std::string   print      (uint32_t depth);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Write_queue/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Write_queue/src/Parameters_msg_error.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Write_queue/src/Parameters_msg_error.cpp	(revision 78)
@@ -22,16 +22,16 @@
 #undef  FUNCTION
 #define FUNCTION "Write_queue::msg_error"
-  std::string Parameters::msg_error(void)
+  Parameters_test Parameters::msg_error(void)
   {
     log_printf(FUNC,Write_queue,FUNCTION,"Begin");
 
-    std::string msg = "";
+    Parameters_test test ("Write_queue");
 
     if (_nb_bypass_write > _size_queue)
-      msg += " * The write_queue can't have more bypass_write than entry in the queue.";
-
-    return msg;
+      test.error("The write_queue can't have more bypass_write than entry in the queue.");
 
     log_printf(FUNC,Write_queue,FUNCTION,"End");
+
+    return test;
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Write_queue/src/Write_queue_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Write_queue/src/Write_queue_allocation.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/Write_queue/src/Write_queue_allocation.cpp	(revision 78)
@@ -53,6 +53,6 @@
        ALLOC_INTERFACE ("write_queue_in", IN, WEST, "Input of write_queue");
        
-       ALLOC_VAL_IN    ( in_WRITE_QUEUE_IN_VAL);
-       ALLOC_ACK_OUT   (out_WRITE_QUEUE_IN_ACK);
+       ALLOC_VALACK_IN ( in_WRITE_QUEUE_IN_VAL,VAL);
+       ALLOC_VALACK_OUT(out_WRITE_QUEUE_IN_ACK,ACK);
        ALLOC_SIGNAL_IN ( in_WRITE_QUEUE_IN_CONTEXT_ID   ,"context_id"   ,Tcontext_t        ,_param->_size_context_id       );
        ALLOC_SIGNAL_IN ( in_WRITE_QUEUE_IN_FRONT_END_ID ,"front_end_id" ,Tcontext_t        ,_param->_size_front_end_id     );
@@ -76,6 +76,6 @@
        ALLOC_INTERFACE ("write_queue_out", OUT, EAST, "Output of write_queue");
        
-       ALLOC_VAL_OUT   (out_WRITE_QUEUE_OUT_VAL);
-       ALLOC_ACK_IN    ( in_WRITE_QUEUE_OUT_ACK);
+       ALLOC_VALACK_OUT(out_WRITE_QUEUE_OUT_VAL,VAL);
+       ALLOC_VALACK_IN ( in_WRITE_QUEUE_OUT_ACK,ACK);
        ALLOC_SIGNAL_OUT(out_WRITE_QUEUE_OUT_CONTEXT_ID   ,"context_id"   ,Tcontext_t     ,_param->_size_context_id   );
        ALLOC_SIGNAL_OUT(out_WRITE_QUEUE_OUT_FRONT_END_ID ,"front_end_id" ,Tcontext_t     ,_param->_size_front_end_id );
@@ -94,6 +94,6 @@
        ALLOC1_INTERFACE("gpr_write", OUT, SOUTH ,"Output of write_queue", _param->_nb_gpr_write);
 
-       ALLOC1_VAL_OUT   (out_GPR_WRITE_VAL);
-       ALLOC1_ACK_IN    ( in_GPR_WRITE_ACK);
+       ALLOC1_VALACK_OUT(out_GPR_WRITE_VAL,VAL);
+       ALLOC1_VALACK_IN ( in_GPR_WRITE_ACK,ACK);
        ALLOC1_SIGNAL_OUT(out_GPR_WRITE_OOO_ENGINE_ID,"ooo_engine_id",Tcontext_t        ,_param->_size_ooo_engine_id   );
        ALLOC1_SIGNAL_OUT(out_GPR_WRITE_NUM_REG      ,"num_reg"      ,Tgeneral_address_t,_param->_size_general_register);
@@ -105,6 +105,6 @@
        ALLOC1_INTERFACE("spr_write", OUT, SOUTH ,"Output of write_queue", _param->_nb_spr_write);
 
-       ALLOC1_VAL_OUT   (out_SPR_WRITE_VAL);
-       ALLOC1_ACK_IN    ( in_SPR_WRITE_ACK);
+       ALLOC1_VALACK_OUT(out_SPR_WRITE_VAL,VAL);
+       ALLOC1_VALACK_IN ( in_SPR_WRITE_ACK,ACK);
        ALLOC1_SIGNAL_OUT(out_SPR_WRITE_OOO_ENGINE_ID,"ooo_engine_id",Tcontext_t        ,_param->_size_ooo_engine_id   );
        ALLOC1_SIGNAL_OUT(out_SPR_WRITE_NUM_REG      ,"num_reg"      ,Tspecial_address_t,_param->_size_special_register);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/include/Parameters.h	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/include/Parameters.h	(revision 78)
@@ -74,5 +74,5 @@
   public : ~Parameters () ;
 
-  public :        std::string   msg_error  (void);
+  public :        Parameters_test msg_error  (void);
 
   public :        std::string   print      (uint32_t depth);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/src/Parameters_msg_error.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/src/Parameters_msg_error.cpp	(revision 78)
@@ -20,16 +20,16 @@
 #undef  FUNCTION
 #define FUNCTION "Write_unit::msg_error"
-  std::string Parameters::msg_error(void)
+  Parameters_test Parameters::msg_error(void)
   {
     log_printf(FUNC,Write_unit,FUNCTION,"Begin");
 
-    std::string msg = "";
+    Parameters_test test ("Write_unit");
 
     if (_size_write_queue == 0)
-      msg += " * Write queue must have a less one entry.";
-
-    return msg;
+      test.error("Write queue must have a less one entry.");
 
     log_printf(FUNC,Write_unit,FUNCTION,"End");
+
+    return test;
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/src/Write_unit_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/src/Write_unit_allocation.cpp	(revision 77)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Write_unit/Write_unit/src/Write_unit_allocation.cpp	(revision 78)
@@ -59,6 +59,6 @@
        ALLOC_INTERFACE ("write_unit_in", IN, WEST, "Input of write_unit");
        
-       ALLOC_VAL_IN    ( in_WRITE_UNIT_IN_VAL);
-       ALLOC_ACK_OUT   (out_WRITE_UNIT_IN_ACK);
+       ALLOC_VALACK_IN ( in_WRITE_UNIT_IN_VAL,VAL);
+       ALLOC_VALACK_OUT(out_WRITE_UNIT_IN_ACK,ACK);
        ALLOC_SIGNAL_IN ( in_WRITE_UNIT_IN_CONTEXT_ID   ,"context_id"   ,Tcontext_t        ,_param->_size_context_id       );
        ALLOC_SIGNAL_IN ( in_WRITE_UNIT_IN_FRONT_END_ID ,"front_end_id" ,Tcontext_t        ,_param->_size_front_end_id     );
@@ -82,6 +82,6 @@
        ALLOC_INTERFACE ("write_unit_out", OUT, EAST, "Output of write_unit");
        
-       ALLOC_VAL_OUT   (out_WRITE_UNIT_OUT_VAL);
-       ALLOC_ACK_IN    ( in_WRITE_UNIT_OUT_ACK);
+       ALLOC_VALACK_OUT(out_WRITE_UNIT_OUT_VAL,VAL);
+       ALLOC_VALACK_IN ( in_WRITE_UNIT_OUT_ACK,ACK);
        ALLOC_SIGNAL_OUT(out_WRITE_UNIT_OUT_CONTEXT_ID   ,"context_id"   ,Tcontext_t     ,_param->_size_context_id   );
        ALLOC_SIGNAL_OUT(out_WRITE_UNIT_OUT_FRONT_END_ID ,"front_end_id" ,Tcontext_t     ,_param->_size_front_end_id );
@@ -100,6 +100,6 @@
        ALLOC1_INTERFACE("gpr_write", OUT, SOUTH ,"Output of write_unit", _param->_nb_gpr_write);
 
-       ALLOC1_VAL_OUT   (out_GPR_WRITE_VAL);
-       ALLOC1_ACK_IN    ( in_GPR_WRITE_ACK);
+       ALLOC1_VALACK_OUT(out_GPR_WRITE_VAL,VAL);
+       ALLOC1_VALACK_IN ( in_GPR_WRITE_ACK,ACK);
        ALLOC1_SIGNAL_OUT(out_GPR_WRITE_OOO_ENGINE_ID,"ooo_engine_id",Tcontext_t        ,_param->_size_ooo_engine_id   );
        ALLOC1_SIGNAL_OUT(out_GPR_WRITE_NUM_REG      ,"num_reg"      ,Tgeneral_address_t,_param->_size_general_register);
@@ -111,6 +111,6 @@
        ALLOC1_INTERFACE("spr_write", OUT, SOUTH ,"Output of write_unit", _param->_nb_spr_write);
 
-       ALLOC1_VAL_OUT   (out_SPR_WRITE_VAL);
-       ALLOC1_ACK_IN    ( in_SPR_WRITE_ACK);
+       ALLOC1_VALACK_OUT(out_SPR_WRITE_VAL,VAL);
+       ALLOC1_VALACK_IN ( in_SPR_WRITE_ACK,ACK);
        ALLOC1_SIGNAL_OUT(out_SPR_WRITE_OOO_ENGINE_ID,"ooo_engine_id",Tcontext_t        ,_param->_size_ooo_engine_id   );
        ALLOC1_SIGNAL_OUT(out_SPR_WRITE_NUM_REG      ,"num_reg"      ,Tspecial_address_t,_param->_size_special_register);
